<?php
$REX['ADDON']['version']['aku_admin'] = '1.15'; 
$REX['ADDON']['author']['aku_admin']='Adrian Kühnis';
$REX['ADDON']['supportblog']['aku_admin'] = 'http://azular.com/';
$REX['ADDON']['navigation']['aku_admin']['block'] = 'system';
$REX['ADDON']['pages']['aku_admin'] = array();
$REX['ADDON']['name']['aku_admin'] = 'Admin';
$REX['AKU_ADMIN_REWRITE'] = 'default';
global $I18N;
if(!is_object($I18N)){
  // in frontend I18N is not known. We must make a fake object until we solve this
  class AKU_ADMIN_I18N {
    public function msg($string){
      return $string;
    }
  }
  $I18N = new AKU_ADMIN_I18N();
}
include_once $REX['INCLUDE_PATH'].'/addons/aku_admin/src/functions.php';
if(!file_exists($REX['HTDOCS_PATH'].'files/addons/aku_admin/aku_admin_settings.php')){
  aku_admin_saveSettings();
}
include $REX['HTDOCS_PATH'].'files/addons/aku_admin/aku_admin_settings.php';

if(isset($REX['AKU_ADMIN_RUNMODE']) && 'dev'== $REX['AKU_ADMIN_RUNMODE']){
  // in development mode, module und templates are updated on every call
  aku_admin_load('AKUAdmin');
  $admin = AKUAdmin::factory(0);
  $admin->SyncTemplates();
  $admin->SyncModules();
}

if (false === $REX['REDAXO'] && $REX['MOD_REWRITE'] !== false){

  // register the url rewrite function
  rex_register_extension('URL_REWRITE', function( $params) {
    global $REX;
    if('&amp;'== substr($params['params'],0,5)){
      $params['params'] = substr($params['params'],5);
    }elseif('?' == substr($params['params'],0,1) ||
    '&' == substr($params['params'],0,1) ){
      $params['params'] = substr($params['params'],1);
    }
    if(''<trim($params['params'])){
      $q = '?';
    }else{
      $q = '';
    }
    if ('slug'==$REX['AKU_ADMIN_REWRITE']){
      $url = '';
      if(1<count($REX['CLANG']) || 
      (isset($REX['AKU_ADMIN_REWRITE_MULTILANG']) && 1 == $REX['AKU_ADMIN_REWRITE_MULTILANG'])
      ){
        // wenn mehr als eine Sprache, language slug voran stellen
        $url.= $REX['CLANG_SLUG'][$params['clang']].'/';
      }
      return $url.$params['id'].'-'.$params['name'].$q.$params['params'];
    
    }elseif('cat'==$REX['AKU_ADMIN_REWRITE']){
      aku_admin_loadPathes();
      $search = '&article_id='.$params['id'].'&clang='.$params['clang'];
      $val = array_search($search,$REX['AKU_ADMIN']['PATHES']);
      if(false === $val){
        // not found try to rebuild
        $REX['AKU_ADMIN']['PATHES'];
        aku_admin_loadPathes(); 
        // try again
        $val = array_search($search,$REX['AKU_ADMIN']['PATHES']);
        if(false === $val){
          // still not found
          return 'url_could_not_be_built';
        }
      }
      // cut off trailing /
      return substr($val,1).$q.$params['params']; 
    } else{
      // default rewrite
      $url = $params['id'].'-';
      if(1<count($REX['CLANG']) || 
      (isset($REX['AKU_ADMIN_REWRITE_MULTILANG']) && 1 == $REX['AKU_ADMIN_REWRITE_MULTILANG'])
      ){
        // wenn mehr als eine Sprache, clang_id anhängen
        $url.=$params['clang'].'-';
      }
      return $url.$params['name'].$q.$params['params'];
    }
  });

  // rewrite url depending on type
  if(isset($_GET['rex_clang_slug'])){
     $clang = array_search($_GET['rex_clang_slug'],$REX['CLANG_SLUG']);
     if(false===$clang){
       $clang = 0;
     }
  }elseif(isset($_GET['article_id'])){
    // default rewrite has catched article_id
    // do nothing
  }else{
    // query von URI abtrennen
    $pos = strpos( $_SERVER['REQUEST_URI'],'?');
    if(false === $pos){
      $url = strtolower($_SERVER['REQUEST_URI']);
    }else{
      $url = strtolower(substr($_SERVER['REQUEST_URI'],0,$pos));
    }
    // im Index nach der url suchen
    aku_admin_loadPathes();
    if(isset($REX['AKU_ADMIN']['PATHES'][$url])){
      // url gefunden 
      $key = $REX['AKU_ADMIN']['PATHES'][$url];
    }elseif(isset($REX['AKU_ADMIN']['PATHES'][$url.'/'])){
      // wurde url ohne / eingegeben
      $key = $REX['AKU_ADMIN']['PATHES'][$url.'/'];
    }else{
      // nicht gefunden
      $key = '&article_id='.$REX['NOTFOUND_ARTICLE_ID'].'-&clang=0';
    }
    $a = explode('&',$key);
    foreach($a as $s){
      if(''==$s) continue;
      if(0 === strpos($s,'article_id=')){
        $article_id = str_replace('article_id=','',$s);
      }elseif(0 === strpos($s,'clang=')){
        $clang = str_replace('clang=','',$s);
      }
    }
  }
}
if(true===$REX['REDAXO']){
  // register language file
  $I18N->appendFile($REX['INCLUDE_PATH'].'/addons/aku_admin/lang/');
  rex_register_extension('OUTPUT_FILTER',function($args){
    global $REX;
    $content = str_replace('</head>',
      "\n".'<link rel="stylesheet" media="all" href="./media/addons/aku_admin/aku_admin.css?ver='.
        filemtime($REX['INCLUDE_PATH'].'/../media/addons/aku_admin/aku_admin.css').'" />'.
      "\n".'<script type="text/javascript" src="./media/addons/aku_admin/aku_admin.js" ></script>'.
      "\n".'</head>',
      $args['subject']);

    $content = str_replace('</body>',
      aku_admin_getHeader().aku_admin_getFooter().'</body>',$content);

    return $content;
  });
}

if(isset($_GET['GetSitemap']) && isset($REX['CLANG'][$_GET['GetSitemap']])){
  rex_register_extension("ADDONS_INCLUDED",function($args){
    global $REX;
    $db = rex_sql::factory();
    $db->setTable($REX['TABLE_PREFIX'].'article');
    $db->setWhere("`startpage` IN (0,1) AND `status`=1".
      " AND `clang`=".$_GET['GetSitemap']);
    $db->select('id,createdate,updatedate');
    while(ob_get_level()) ob_end_clean();
    header('Content-Type: text/xml; charset=UTF-8');
    echo '<?xml version="1.0" encoding="UTF-8"?>'."\n";
    echo '<urlset xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd" xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">' . "\n";
    $rooturl = $REX['SERVER'];
    if('/' != substr($rooturl, -1, 1)){
      $rooturl.='/';
    }
    if(0<$db->getRows()){
      while($row = $db->getRow()){
        $date = 0==$row['updatedate']?$row['createdate']:$row['updatedate'];
        echo '<url>'."\n";
        echo '<loc>'.$rooturl . rex_getUrl($row['id'],$_GET['GetSitemap'],array(),'&amp;').'</loc>'."\n";
        echo '<lastmod>'.date("Y-m-d\TH:i:s",$date)."+00:00</lastmod>\n";
        echo '<changefreq>weekly</changefreq>'."\n";
        echo '<priority>0.5</priority>';
        echo '</url>';
      }
    }
    // ----- EXTENSION POINT
    // page variable validated
    // todo: add extension point
    //rex_register_extension_point('AKU_ADMIN_SITEMAP', NULL, array(),true);
    echo '</urlset>';
    die();
    return;
  });
}
