<?php
AKUAdmin_load('AKUAdminForm');
global $REX,$I18N;


$errMsg = '';
$okMsg = '';

$form = AKUAdminForm::factory("addonform1");
$form->useAjax = true;
$form->setUrl('local_sendForm(this);return false;');

$form->addField('zip','file',0,'','','zip','','');
if(true === $form->isValid()){
  // create temp dir, must be outside addons because aku_admin must update itself
  $dir_tmp = $REX['HTDOCS_PATH'].'files/tmp/';
  if(!is_dir($dir_tmp)){
    mkdir($dir_tmp,0777,true);
    file_put_contents($dir_tmp.'index.html','');
  }
  if(isset($_FILES['zip']['name']) && ''!= $_FILES['zip']['name']){
    move_uploaded_file($_FILES['zip']['tmp_name'],$dir_tmp.$_FILES['zip']['name']);
    // check if is addon (look for config.inc.php
    $zip_rs = zip_open($dir_tmp.$_FILES['zip']['name']);
    $addon = NULL;
    $config = NULL;
    if(is_resource($zip_rs)){
      while ($zip_entry = zip_read($zip_rs)){
        if(zip_entry_open($zip_rs,$zip_entry)){
          // from the first entry we get the module referrer
          $name =  zip_entry_name($zip_entry);
          if(NULL === $addon && ''!=$name){
            $pos = strpos($name,'/');
            if(false === $pos){
              $addon = $name;
            }else{
              $addon = substr($name,0,$pos); // name in front of first '/'
            }
          }
          if(preg_match('/config\.inc\.php$/',$name)){
            // read the zip entry to input
            $config = '';
            while($str = zip_entry_read($zip_entry)){
              $config.=$str;
            }
          }
        }
      }
      zip_close($zip_rs);
    }
    if(NULL === $addon || NULL ===$config){
      // kein korrektes format für eine addon-datei
      $errMsg = $I18N->msg('addon_package_error');
      $form->status = false;
      unlink($dir_tmp.$_FILES['zip']['name']);
    }else{
      // falls Ordner im Temp-Vz. schon existiert, löschen 
      if(is_dir($dir_tmp.$addon)){
        aku_admin_rmdir($dir_tmp.$addon);
      }
      // zip  expandieren in tmp-verz
      if(!aku_admin_unzip($dir_tmp.$_FILES['zip']['name'],$dir_tmp)){
        // unzip erfolgreich, backup entfernen wenn vorhanden
        return array(false,$I18N->msg('error_unzip'));
      }
      
      // Verzeichnis kopieren (nicht ersetzen, damit plugins erhalten bleiben!)
      aku_admin_cpdir($dir_tmp.$addon,$REX['INCLUDE_PATH'].'/addons/'.$addon);

      // zip-datei löschen
      unlink($dir_tmp.$_FILES['zip']['name']);
      // addons-verzichnis erneuenr
      $ADDONS    = rex_read_addons_folder();
      rex_generateAddons($ADDONS);
      $ret = json_encode(array('success'=>true,'message'=>'addon_uploaded','installaddon'=>$addon));
      die($ret);
    }
  }
}elseif($form->isSent()){
  $errMsg = $form->getError();
}
##########################################################################
# Ausgabe 
##########################################################################
echo '<div class="structure_block">';
if(''<$errMsg){
  echo '<p class="error" style="background:red;padding:5px;color:white;">'.$errMsg.'</p>';
}

if(''<$okMsg){
  echo '<p class="ok" style="background:green;padding:5px;color:white;">'.$okMsg.'</p>';
}
echo $form->getFormHeader();
echo '<p>'.$I18N->msg('zip_archive').':<br/> ';
echo $form->getField('zip').
  '<div><i>'.$form->getError('zip').'</i></div></p>';
echo '<p><br/><input type="submit" value="'.
  $I18N->msg('upload_and_install').'" onclick="this.value=\''.
  $I18N->msg('please_wait').'\'" /> ';
echo '<a href="" onclick="location.hash=\'AKUAdmin-0-addons\';return false;">'.
  $I18N->msg('form_abort').'</a></p>';
echo $form->getFormFooter();
echo '</div';

