<?php

class AKUAdmin {

  var $data = array();
  
  static function factory($id){
    $p =  new self();
    $p->data['id'] = 0;
    return $p;
  }

  function getSubPages(){
    return aku_admin_getSystemApps();
  }
  
  function getView($name,$viewparams=''){
    global $REX,$I18N;
    if('users'==$name){
      $aData = array();
      $aData['cur_user'] = array(
        'user_id'=>$REX['USER']->getValue('user_id'),
      );
      $aData['user'] = array();
      $db = rex_sql::factory();
      $db->setTable($REX['TABLE_PREFIX'].'user');
      $db->select('*');
      if(0<$db->getRows()){
        $i=0;
        while($row = $db->getRow()){
          $aData['user'][$i]['user_id'] = $row['user_id'];
          $aData['user'][$i]['name'] = $row['name'];
          $aData['user'][$i]['login'] = $row['login'];
          $aData['user'][$i]['lasttrydate'] = date("d.m.Y H:i",$row['lasttrydate']);
          $i++;
        }
      }
      return json_encode($aData);
    }elseif('modules' === $name){
      $aData =array();
      // moduleupload before modules are loaded
      /*
      if('moduleupload'==$viewparams){
        $aData['moduleupload'] = $this->getView('moduleupload');
      }else{
        $aData['moduleupload'] = '';
      }
      */
      $MODULES = array();
      $MODULES_IN_DB = array();
      // read modules available in the file system
      $dir = aku_admin_getModuleDir();
      foreach(scandir($dir) as $f){
        if('.'==$f) continue;
        if('..'==$f) continue;
        if(!is_dir($dir.$f)) continue;
        if(file_exists($dir.$f.'/output.php')){
          $MODULES[] = $f;
        }
      }
      $aData['module'] =array();
      $db = rex_sql::factory();
      $db->setTable($REX['TABLE_PREFIX'].'module');
      $db->setWhere("1 ORDER BY `name` ASC");
      $db->select('*');
      if(0==$db->getRows()){
        return '[]';
      }
      $i=0;
      while ($row = $db->getRow()){
        $MODULES_IN_DB[] = $row['mod_type'];
        $aData['module'][$i]['id'] = $row['id'];
        $aData['module'][$i]['name'] = $row['name'];
        $aData['module'][$i]['revision'] = $row['revision'];
        $aData['module'][$i]['mod_type'] = $row['mod_type'];
        $aData['module'][$i]['createdate'] = intval($row['createdate']);
        $u = 0==$row['updatedate']?$row['createdate']:$row['updatedate'];
        $aData['module'][$i]['updatedate'] = date("d.m.Y H:i",$u);
        $i++;
      }
      $uninstalled = array_diff($MODULES,$MODULES_IN_DB);
      foreach($uninstalled as $t){
        $aData['module'][$i]['id'] = 0;
        $aData['module'][$i]['name'] = '';
        $aData['module'][$i]['mod_type'] = $t;
        $aData['module'][$i]['revision'] = 0;
        $i++;
      }
      /*
      if(preg_match('/^edit\_([0-9]+)$/',$viewparams,$matches)){
        $aData['editmodule'] = $this->getView('editmodule',$matches[1]);
      }else{
        $aData['editmodule'] = '';
      }
      */
      $aData['pages'] = $this->getSubPages();
      return json_encode($aData);

    }elseif('languages'==$name){
      $aData =array();
      $aData['clang'] =array();
      $db = rex_sql::factory();
      $db->setTable($REX['TABLE_PREFIX'].'clang');
      $db->setWhere("1 ORDER BY `id` ASC");
      $db->select('*');
      if(0<$db->getRows()){
        $i=0;
        while($row=$db->getRow()){
          $aData['clang'][$i]['id'] = $row['id'];
          $aData['clang'][$i]['name'] = $row['name'];
          $aData['clang'][$i]['code'] = isset($REX['CLANG_CODE'][$row['id']])?$REX['CLANG_CODE'][$row['id']]:'';
          $aData['clang'][$i]['slug'] = isset($REX['CLANG_SLUG'][$row['id']])?$REX['CLANG_SLUG'][$row['id']]:'';
          $i++;
        }
      }

      $aData['pages'] = $this->getSubPages();
      return json_encode($aData);
    }elseif('addons'==$name){
      $aData =array();
      /*
      if('addonupload'==$viewparams){
        $aData['addonupload'] = $this->getView('addonupload');
      }else{
        $aData['addonupload'] = ''; 
      } 
      */
      // Addon-Liste aktualisieren
      $ADDONS    = rex_read_addons_folder();
      if (count(array_diff($ADDONS, OOAddon::getRegisteredAddons())) > 0 ||
      count(array_diff(OOAddon::getRegisteredAddons(), $ADDONS)) > 0) {
        rex_generateAddons($ADDONS);
      }
      sort($ADDONS);
      // read the plugins
      $PLUGINS = array();
      foreach($ADDONS as $_addon){
        $PLUGINS[$_addon] = rex_read_plugins_folder($_addon);
      }
      $aData['addon'] =array();
      $z = 0;
      for($i=0;$i<count($ADDONS);$i++){
        $addon = $ADDONS[$i];
        $aData['addon'][$z]['type'] = 'addon';
        $aData['addon'][$z]['name'] = $addon;
        $aData['addon'][$z]['install'] = $REX['ADDON']['install'][$addon];
        $aData['addon'][$z]['active']  = $REX['ADDON']['status'][$addon];
        $aData['addon'][$z]['system']  = OOAddon::isSystemAddon($addon);
        $aData['addon'][$z]['version'] = isset($REX['ADDON']['version'][$addon])?$REX['ADDON']['version'][$addon]:'';
        $aData['addon'][$z]['plugins']  = 0;
        $pos = $z; // merken
        $z++;
        if(isset($PLUGINS[$addon])){
          for($j=0;$j<count($PLUGINS[$addon]);$j++){
            $plugin = $PLUGINS[$addon][$j];
            $aData['addon'][$z]['type'] = 'plugin';
            $aData['addon'][$z]['name'] = $plugin;
            $aData['addon'][$z]['install'] = $REX['ADDON']['plugins'][$addon]['install'][$plugin];
            $aData['addon'][$z]['active']  = $REX['ADDON']['plugins'][$addon]['status'][$plugin];
            $aData['addon'][$z]['system'] = false;
            $aData['addon'][$z]['version'] = isset($REX['ADDON']['version'][$plugin])?$REX['ADDON']['version'][$plugin]:'';
            if(1==$REX['ADDON']['plugins'][$addon]['install'][$plugin]){
               $aData['addon'][$pos]['plugins']++;
            }
            $z++;
          }
        }
      }
      $aData['pages'] = $this->getSubPages();
      return json_encode($aData);
    }elseif('templates'==$name){
      $aData =array();
      /*
      if('templateupload'==$viewparams){
        $aData['templateupload'] = $this->getView('templateupload');
      }else{
        $aData['templateupload'] = '';
      }
      */
      if(preg_match('/^edit\_([0-9]+)$/',$viewparams,$matches)){
        $aData['edittemplate'] = $this->getView('edittemplate',$matches[1]);
      }else{
        $aData['edittemplate'] = '';
      }
      $aData['template'] =array();
      $TEMPLATES = array();
      $TEMPLATES_IN_DB = array();
      // read templates available in the file system
      $dir = aku_admin_getTemplateDir();
      foreach(scandir($dir) as $t){
        if('.'==$t) continue;
        if('..'==$t) continue;
        if(!is_dir($dir.$t)) continue;
        if(file_exists($dir.$t.'/content.php')){
          $TEMPLATES[] = $t;
        }
      }
      // get all templates from the db
      $db = rex_sql::factory();
      $db->setTable($REX['TABLE_PREFIX'].'template');
      $db->setWhere('1 ORDER BY `name` ASC');
      $db->select('*');
      if(0<$db->getRows()){
        $i=0;
        while($row = $db->getRow()){
          $TEMPLATES_IN_DB[] = $row['tmpl_type'];
          $aData['template'][$i] = $row;
          $aData['template'][$i]['setup'] = file_exists($REX['HTDOCS_PATH'].
            'templates/'.$row['tmpl_type'].'/setup.php');
          $i++;
        }
      }
      $uninstalled = array_diff($TEMPLATES,$TEMPLATES_IN_DB);
      foreach($uninstalled as $t){
        $aData['template'][$i]['id'] = 0;
        $aData['template'][$i]['setup'] = false;
        $aData['template'][$i]['name'] = $t;
        $aData['template'][$i]['tmpl_type'] = $t;
        $aData['template'][$i]['active'] = 0;
        $i++;
      }
      $aData['pages'] = $this->getSubPages();
      return json_encode($aData);
    }elseif('info'==$name){
      $aData = array();
      $aData['pages'] = $this->getSubPages();
      ob_start();
      include $REX['INCLUDE_PATH'].'/addons/aku_admin/src/view.AKUAdmin.info.php';
      $aData['info'] = ob_get_clean();
      return json_encode($aData);

    }elseif('backupexport'==$name){
      $aData = array();
      $aData['pages'] = $this->getSubPages();
      $aData['dbexport'] = array();
      $dir = aku_admin_getBackupDir();
      $i=0;
      foreach(scandir($dir) as $file){
        if('.sql'!=substr($file,-4)) continue;
        $aData['dbexport'][$i]['name'] = $file;
        $aData['dbexport'][$i]['size'] = filesize($dir.$file);
        $aData['dbexport'][$i]['mtime'] = filemtime($dir.$file);
        $i++;
      }
      
      return json_encode($aData);
    }else{
      ob_start();
      $view = $REX['INCLUDE_PATH'].'/addons/aku_admin/src/view.AKUAdmin.'.$name.'.php';
      if(file_exists($view)){
        include $view;
      }
      return ob_get_clean();
    }
  }
  function getValue($name){
    if(isset($this->data[$name])){
      return $this->data[$name];
    }else{
      return null;
    }
  }

  function SyncModules(){
    global $REX,$I18N;
    $db = rex_sql::factory();
    $db->setTable($REX['TABLE_PREFIX'].'module');
    $db->setWhere("`mod_type` != ''");
    $db->select('*');
    if(0<$db->getRows()){
      aku_admin_load('AKUAdmin');
      while($row=$db->getRow()){
        $dir = aku_admin_getModuleDir().$row['mod_type'].'/';
        if(!is_dir($dir)) continue; 
        if((file_exists($dir.'input.php') && filemtime($dir.'input.php') > ($row['updatedate'] + 10 )) ||
        (file_exists($dir.'output.php') && filemtime($dir.'output.php') > ($row['updatedate'] + 10 )) ||
        (file_exists($dir.'package.yml') && filemtime($dir.'package.yml') > ($row['updatedate'] + 10 )) ||
        (file_exists($dir.'preview.php') && filemtime($dir.'preview.php') > ($row['updatedate'] + 10 )) ||
        (file_exists($dir.'presave.php') && filemtime($dir.'presave.php') > ($row['updatedate'] + 10 )) ||
        (file_exists($dir.'postsave.php') && filemtime($dir.'postsave.php') > ($row['updatedate'] + 10 )) 
        ){
          // module needs update
          $this->ModuleInstall($row['mod_type']);
        }
      }
    }
    return array(true,'');
  }
  function SyncTemplates(){
    global $REX,$I18N;
    $db = rex_sql::factory();
    $db->setTable($REX['TABLE_PREFIX'].'template');
    $db->setWhere("`tmpl_type` != ''");
    $db->select('*');
    if(0<$db->getRows()){
      aku_admin_load('AKUTemplate');
      while($row=$db->getRow()){
        $dir = aku_admin_getTemplateDir().$row['tmpl_type'].'/';
        if(!is_dir($dir)) continue; 
        if((file_exists($dir.'content.php') && filemtime($dir.'content.php') > ($row['updatedate'] + 10 )) ||
        (file_exists($dir.'package.yml') && filemtime($dir.'package.yml') > ($row['updatedate'] + 10 )) 
        ){
          // template nees update
          $tmpl = AKUTemplate::factory($row['id']); // create from the id to load actions, too
          $tmpl->setValue('revision',0);
          $tmpl->setValue('content','');
          if(file_exists($dir.'content.php')){
            $tmpl->setValue('content',file_get_contents($dir.'content.php'));
          }
          if(file_exists($dir.'output.php')){
            $tmpl->setValue('ausgabe',file_get_contents($dir.'output.php'));
          }
          if(file_exists($dir.'package.yml')){
            $package = file_get_contents($dir.'package.yml');
            if(preg_match('/revision.*([0-9]+)/',$package,$matches)){
              $tmpl->setValue('revision',intval($matches[1]));
            }
          }
          $tmpl->save();
        }
      }
    }
    return array(true,'');
  }
  
  
 function ShowAddons($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    return array(true,$this->getView('addons',$params));
 }
 function ShowModules($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    return array(true,$this->getView('modules',$params));
 }
  function ShowUploadmodule($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    return array(true,$this->getView('uploadmodule'));
  }

  // ModuleInstall installs a module from the file system into the database
  // if the module is already present, it is updated
  // @param $mod_type string directory name
  // @return {bool success , string message}
  function ModuleInstall($mod_type){
    global $REX,$I18N;
    AKUAdmin_load('AKUModule');
    $dir = aku_admin_getModuleDir();
    if(!is_dir($dir.$mod_type)){
      return array(false,'module_directory_not_found');
    }
    if(!file_exists($dir.$mod_type.'/output.php')){
      return array(false,'no_ouput_file_found');
    }
    $db = rex_sql::factory();
    $db->setTable($REX['TABLE_PREFIX'].'module');
    $db->setWhere("`mod_type`='".$db->escape($mod_type)."' LIMIT 1");
    $db->select('id');
    AKUAdmin_load('AKUModule');
    $isNew = false;
    if(0==$db->getRows()){
      $mod = AKUModule::factory(0);
      $mod->setValue('mod_type',$mod_type);
      $mod->setValue('name',$mod_type); // preset fall keine package.yml
      $isNew = true;
    }else{
      // create module. use id only because module also loads actions
      $row = $db->getRow();
      $mod = AKUModule::factory($row['id']);
    }
    $mod->setValue('ausgabe','');
    if(file_exists($dir.$mod_type.'/output.php')){
      $mod->setValue('ausgabe',file_get_contents($dir.$mod_type.'/output.php'));
    }
    $mod->setValue('eingabe','');
    if(file_exists($dir.$mod_type.'/input.php')){
      $mod->setValue('eingabe',file_get_contents($dir.$mod_type.'/input.php'));
    }
    $mod->setValue('preview','');
    if(file_exists($dir.$mod_type.'/preview.php')){
      $mod->setValue('preview',file_get_contents($dir.$mod_type.'/preview.php'));
    }
    $mod->setValue('presave','');
    if(file_exists($dir.$mod_type.'/presave.php')){
      $mod->setValue('presave',file_get_contents($dir.$mod_type.'/presave.php'));
    }
    $mod->setValue('postsave','');
    if(file_exists($dir.$mod_type.'/postsave.php')){
      $mod->setValue('postsave',file_get_contents($dir.$mod_type.'/postsave.php'));
    }
    $mod->setValue('revision',0);
    $mod->setValue('previewmode',0);
    $mod->setValue('presavemode',0);
    $mod->setValue('postsavemode',0);
    if(file_exists($dir.$mod_type.'/package.yml')){
      $package = file_get_contents($dir.$mod_type.'/package.yml');
      // read data from package 
      if(preg_match('/revision.*([0-9]+)/',$package,$matches)){
        $mod->setValue('revision',intval($matches[1]));
      }
      if(preg_match('/previewmode.*([0-9]+)/',$package,$matches)){
        $mod->setValue('previewmode',intval($matches[1]));
      }
      if(preg_match('/presavemode.*([0-9]+)/',$package,$matches)){
        $mod->setValue('presavemode',intval($matches[1]));
      }
      if(preg_match('/postsavemode.*([0-9]+)/',$package,$matches)){
        $mod->setValue('postsavemode',intval($matches[1]));
      }
      if(0==$mod->getValue('id')){
        // nur wenn Modul noch nicht existiert
        if(preg_match('/name[ :]+(.+)/',$package,$matches)){
          $mod->setValue('name',trim($matches[1]));
        }
      }
    }
    $mod->save();
    if($isNew){
      $message = str_replace('{0}',$mod_type,$I18N->msg('module_installed'));
    }else{
      $message = str_replace('{0}',$mod_type,$I18N->msg('module_updated'));
    }
    return array(true,$message);
  }

  function ShowUploadaddon($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    return array(true,'');//$this->getView('uploadaddon'));
  }
 
 function ShowTemplates($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    return array(true,$this->getView('templates',$params));
 }
  function TemplateInstall($tmpl_type){
    global $REX,$I18N;
    AKUAdmin_load('AKUTemplate');
    $dir = aku_admin_getTemplateDir();
    if(!is_dir($dir.$tmpl_type)){
      return array(false,'template_directory_not_found');
    }
    if(!file_exists($dir.$tmpl_type.'/content.php')){
      return array(false,'no_content_file_found');
    }
    // check if it's a new install or already existing in db
    $db = rex_sql::factory();
    $db->setTable($REX['TABLE_PREFIX'].'template');
    $db->setWhere("`tmpl_type`='".$db->escape($tmpl_type)."'");
    $db->select('id');
    $isNew = false;
    if(0==$db->getRows()){
      $tmpl = AKUTemplate::factory(0);
      $tmpl->setValue('tmpl_type',$tmpl_type);
      // preset falls keine package.yml
      $tmpl->setValue('name',$tmpl_type); 
      $tmpl->setValue('active',1);
      $tmpl->setValue('revision',0);
      $isNew = true;
    }else{
      $row = $db->getRow();
      $tmpl = AKUTemplate::factory($row['id']);
    }
    $tmpl->setValue('content',file_get_contents($dir.$tmpl_type.'/content.php'));
    if(file_exists($dir.$tmpl_type.'/package.yml')){
      $package = file_get_contents($dir.$tmpl_type.'/package.yml');
      // read data from package 
      if(preg_match('/revision.*([0-9]+)/',$package,$matches)){
        $tmpl->setValue('revision',intval($matches[1]));
      }
      if($isNew){
        // nur wenn Template noch nicht existiert
        if(preg_match('/name[ :]+(.+)/',$package,$matches)){
          $tmpl->setValue('name',trim($matches[1]));
        }
      }
    }
    $tmpl->save();
    if($isNew){
      $message = str_replace('{0}',$tmpl_type,$I18N->msg('template_installed'));
    }else{
      $message = str_replace('{0}',$tmpl_type,$I18N->msg('template_updated'));
    }
    return array(true,$message);
  }
 function CreateZipExport($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
   $datafile = $REX['INCLUDE_PATH'].'/addons/aku_admin/backup/backup.json';
   if(!file_exists($datafile)){
     return array(false,'prepare_download_first');
   }
   // aktuelle Daten einlesen
   $data = json_decode(file_get_contents($datafile),true);
   $fh = fopen($REX['INCLUDE_PATH'].'/addons/aku_admin/backup/backuplist.txt','r');
   fseek($fh,$data['fseek']); // zeiger positionieren
   if(is_resource($fh)){
     $zip = new ZipArchive;
     $res = $zip->open($REX['INCLUDE_PATH'].'/addons/aku_admin/backup/backup.zip',ZipArchive::CREATE);
     if(true === $res){
       $base = realpath($REX['INCLUDE_PATH'].'/../../').'/';
       $count = 0;
       while($f = trim(fgets($fh))){
         if(is_file($base.$f)){
           $count++;
           $zip->addFile($base.$f,$f);
         }
         if(1000==$count) break;
       }
       $zip->close();
       $data['filecount'] = $data['filecount'] - $count;
       $data['fseek'] = ftell($fh);
       file_put_contents($datafile,json_encode($data));
       fclose($fh);
       return array(true,json_encode($data));
     }else{
       return array(false,'zip not opened');
     }
   }else{
     return array(false,'backuplist not found');
   }
 }

 function PrepareZipExport($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }

   function appendFiles($dir,&$fh,&$zipsize,&$filecount){
     foreach(scandir($dir) as $file){
       if('.'==$file || '..'==$file) continue;
       if(is_dir($dir.$file)){
         appendFiles($dir.$file.'/',$fh,$zipsize,$filecount);
       }else{
         $zipsize+= filesize($dir.$file);
         $filecount++;
         fwrite($fh,str_replace('../','',$dir.$file)."\n");
       }
     }
   }
   $dir = $REX['INCLUDE_PATH'].'/addons/aku_admin/backup/';
   // remove existing zip
   foreach($dir as $file){
     if('.zip'==substr($file,-4)){
       unlink($dir.$file);
     }
   }
   // create the new file list
   $file = $dir.'backuplist.txt';
   $fh = fopen($file,'w');
   $totalsize = 0;
   $filecount = 0;
   $startdir = '../';
   appendFiles($startdir,$fh,$totalsize,$filecount); 
   fclose($fh);
   file_put_contents($REX['INCLUDE_PATH'].'/addons/aku_admin/backup/backup.json',
     json_encode(array(
       'filecount'=>$filecount,
       'totalsize'=>$totalsize,
       'fseek'=>0)));
   return array(true,json_encode(array('size'=>$size)));
 }


 
 function ShowInfo($params = ''){
   // info is available also for non-admin
    return array(true,$this->getView('info',$params));
 }
 function ShowBackupExport($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    return array(true,$this->getView('backupexport',$params));
 }
  function DownloadExport($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    $dir = aku_admin_getBackupDir();
    if(!preg_match('/^[0-9a-z\.\-_]+$/',$params)){ 
     return array(false,'not correct');
    }
    if(!file_exists($dir.$params)){
     return array(false,'not found '.$dir.$params);
    }

   if('.sql'== substr($params,-4)){
    header("Content-Type: text/sql");
    header('Content-Length: ' . filesize($dir.$params));
    header('Content-Disposition: attachment; filename="'.$params.'"');
    readfile($dir.$params); 
    exit;
   }
     
 }
  function DeleteExport($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    $dir = aku_admin_getBackupDir();
    if(!preg_match('/^[0-9a-z\.\-_]+$/',$params)){ 
     return array(false,'not correct');
    }
    if(!file_exists($dir.$params)){
     return array(false,'not found '.$dir.$params);
    }
    unlink($dir.$params);
    return array(true,'');
  }

##############################################
# DB Export 
##############################################
  function CreateDbExport(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    //$server = preg_replace('@^https?://|/.*|[^\w.-]@', '', $REX['SERVER']);
    $server = preg_replace('@^https?://@', '', $REX['SERVER']);
    $server = preg_replace('@[^\w.-]@', '_', $server);
    $filename = aku_admin_getBackupDir().
       strtolower($server).'_rex'.$REX['VERSION'].$REX['SUBVERSION'].$REX['MINORVERSION'].
       '_'.date("Ymd_Hi").'.sql';
    $fp = @fopen($filename, "w");
    if (!$fp) {
      return array(false,'could not create backup file');
    }

    $sql        = rex_sql::factory();
    $tables     = rex_sql::showTables(1, $REX['TABLE_PREFIX']);

    $nl         = "\n";
    $insertSize = 5000;


    // Versionsstempel hinzufügen
    fwrite($fp, '## Redaxo Database Dump Version '.$REX['VERSION'].$nl);
    fwrite($fp, '## Prefix '.$REX['TABLE_PREFIX'].$nl);
    fwrite($fp, '## charset UTF-8'.$nl.$nl);

    foreach ($tables as $table) {
      if (0 !== strpos($table,$REX['TABLE_PREFIX'])){
        continue;
      }
      //---- export metadata
      $create = rex_sql::showCreateTable($table);

      fwrite($fp, "DROP TABLE IF EXISTS `$table`;\n");
      fwrite($fp, "$create;\n");

      $fields = $sql->getArray("SHOW FIELDS FROM `$table`");

      foreach ($fields as $idx => $field) {
        if (preg_match('#^(bigint|int|smallint|mediumint|tinyint|timestamp)#i', $field['Type'])) {
          $fields[$idx] = 'int';
        } elseif (preg_match('#^(float|double|decimal)#', $field['Type'])) {
          $fields[$idx] = 'double';
        } elseif (preg_match('#^(char|varchar|text|longtext|mediumtext|tinytext)#', $field['Type'])) {
            $fields[$idx] = 'string';
        }
      }

      //---- export tabledata
      $start = 0;
      $max   = $insertSize;

      do {
        $sql->freeResult();
        $sql->setQuery("SELECT * FROM `$table` LIMIT $start,$max");

        if ($sql->getRows() > 0 && $start == 0) {
          fwrite($fp, "\nLOCK TABLES `$table` WRITE;");
          fwrite($fp, "\n/*"."*!40000 ALTER TABLE `$table` DISABLE KEYS *"."/;");
        } elseif ($sql->getRows() == 0) {
            break;
        }

        $start += $max;
        $values = array();

        while($sql->hasNext()) {
          $record = array();

          foreach ($fields as $idx => $type) {
            $column = $sql->getValue($idx);

            switch ($type) {
              case 'int':
                $record[] = intval($column);
                break;
              case 'double':
                $record[] = sprintf('%.10F', (double) $column);
                break;
              case 'string':
              default:
                $record[] = $sql->escape($column, "'", true);
                break;
            }
          }

          $values[] = $nl .'  ('.implode(',', $record).')';
          $sql->next();
        }

        if (!empty($values)) {
          $values = implode(',', $values);
          fwrite($fp, "\nINSERT INTO `$table` VALUES $values;");
          unset($values);
        }
      } while ($sql->getRows() >= $max);

      if ($start > 0) {
        fwrite($fp, "\n/"."*!40000 ALTER TABLE `$table` ENABLE KEYS *"."/;");
        fwrite($fp, "\nUNLOCK TABLES;\n\n");
      }
    }
    fclose($fp);
    return array(true,"");
  }

##############################################
# Addons 
##############################################
// Because addons may have a '-' in their names we cannot call their class
// directly but user AKUAdmin as a hub
// access control is done in the addon object
  public function AddonActivate($addon){
    global $REX,$I18N;
    aku_admin_load('AKUAddon');
    $o = AKUAddon::factory($addon);
    if(NULL === $o){
      return array(false,$I18N->msg('no_access'));
    }else{
      return $o->Activate();
    }
  }
  public function AddonDeactivate($addon){
    global $REX,$I18N;
    aku_admin_load('AKUAddon');
    $o = AKUAddon::factory($addon);
    if(NULL === $o){
      return array(false,$I18N->msg('no_access'));
    }else{
      return $o->Deactivate();
    }
  }
  public function AddonInstall($addon){
    global $REX,$I18N;
    aku_admin_load('AKUAddon');
    $o = AKUAddon::factory($addon);
    if(NULL === $o){
      return array(false,$I18N->msg('no_access'));
    }else{
      return $o->Install();
    }
  }
  public function AddonUninstall($addon){
    global $REX,$I18N;
    aku_admin_load('AKUAddon');
    $o = AKUAddon::factory($addon);
    if(NULL === $o){
      return array(false,$I18N->msg('no_access'));
    }else{
      return $o->Uninstall();
    }
  }
  public function AddonDelete($addon){
    global $REX,$I18N;
    aku_admin_load('AKUAddon');
    $o = AKUAddon::factory($addon);
    if(NULL === $o){
      return array(false,$I18N->msg('no_access'));
    }else{
      return $o->Delete();
    }
  }
##############################################
# Plugins 
##############################################
// Because plugins may have a '-' in their names we cannot call their class
// directly but user AKUAdmin as a hub
// access control is done in the plugin object
  public function PluginActivate($plugin){
    global $REX,$I18N;
    aku_admin_load('AKUPlugin');
    $o = AKUPlugin::factory($plugin);
    if(NULL === $o){
      return array(false,$I18N->msg('no_access'));
    }else{
      return $o->Activate();
    }
  }
  public function PluginDeactivate($plugin){
    global $REX,$I18N;
    aku_admin_load('AKUPlugin');
    $o = AKUPlugin::factory($plugin);
    if(NULL === $o){
      return array(false,$I18N->msg('no_access'));
    }else{
      return $o->Deactivate();
    }
  }
  public function PluginInstall($plugin){
    global $REX,$I18N;
    aku_admin_load('AKUPlugin');
    $o = AKUPlugin::factory($plugin);
    if(NULL === $o){
      return array(false,$I18N->msg('no_access'));
    }else{
      return $o->Install();
    }
  }
  public function PluginUninstall($plugin){
    global $REX,$I18N;
    aku_admin_load('AKUPlugin');
    $o = AKUPlugin::factory($plugin);
    if(NULL === $o){
      return array(false,$I18N->msg('no_access'));
    }else{
      return $o->Uninstall();
    }
  }
  public function PluginDelete($plugin){
    global $REX,$I18N;
    aku_admin_load('AKUPlugin');
    $o = AKUPlugin::factory($plugin);
    if(NULL === $o){
      return array(false,$I18N->msg('no_access'));
    }else{
      return $o->Delete();
    }
  }
##############################################
# lanugaes 
##############################################
function ShowAddClang($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    AKUAdmin_load("AKUClang");
    $o = AKUClang::factory(-1);
    return array(true,$o->getView('edit'));
 }
 function ShowLanguages($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    return array(true,$this->getView('languages'));
  }
##############################################
# users 
##############################################
  function ShowUsers($params = ''){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    return array(true,$this->getView('users'));
  }

##############################################
# Upload Module 
##############################################
  function UploadModule($name){
    global $REX,$I18N;
    // detect the encoding of the file name
    $detect = array('UTF-8','ISO-8859-1');
    $name = ('ISO-8859-1'==mb_detect_encoding($name,$detect))?utf8_encode($name):$name; 
    // Check file type
    if (!preg_match('/.zip$/',strtolower($name))){
      return array(false,$I18N->msg('no_zip'));
    }
    // Datei herunterladen in eine temporäre datei im Zielverzeichnis
    $input = fopen("php://input", "r");
    $temp = tmpfile();
    $realSize = stream_copy_to_stream($input, $temp);
    fclose($input);  
    // kopieren in tmp-verzeichnis
    $dir_tmp = aku_admin_getTmpDir();
    $file = $dir_tmp.$name;//tempnam($dir,'temporary');
    $target = fopen($file, "w");        
    fseek($temp, 0, SEEK_SET);
    stream_copy_to_stream($temp, $target);
    fclose($target);

    // check if is module
    $zip_rs = zip_open($file);
    $module   = NULL;
    $output   = NULL;
    if(is_resource($zip_rs)){
      while ($zip_entry = zip_read($zip_rs)){
        if(zip_entry_open($zip_rs,$zip_entry)){
          // from the first entry we get the module referrer
          $name =  zip_entry_name($zip_entry);
          if(NULL === $module && ''!=$name){
            $pos = strpos($name,'/');
            if(false === $pos){
              $module = strtolower($name);
            }else{
              $module = strtolower(substr($name,0,$pos));
            }
          }
          if(preg_match('/output\.php$/',strtolower($name))){
            // read the zip entry to output
            $output = '';
          }
        }
      }
      zip_close($zip_rs);
    }
    if(NULL === $module || NULL ===$output){
      // kein korrektes format für eine modul-datei
      unlink($file);
      return array(false,$I18N->msg('module_package_error'));

    }else{
      // falls Ordner im Temp-Verzeichnis schon existiert, löschen 
      if(is_dir($dir_tmp.$module)){
        aku_admin_rmdir($dir_tmp.$module);
      }
      // zip  expandieren in tmp-verz
      if(!aku_admin_unzip($file,$dir_tmp)){
        // unzip erfolgreich, backup entfernen wenn vorhanden
        unlink($file);
        return array(false,$I18N->msg('error_unzip'));
      }
      // Verzeichnis kopieren (nicht ersetzen!)
      aku_admin_cpdir($dir_tmp.$module,aku_admin_getModuleDir().$module);
      // zip-datei löschen
      unlink($file);
      // add to database
      return $this->ModuleInstall($module);      
    }
  }
##############################################
# Upload Template 
##############################################
  function UploadTemplate($name){
    global $REX,$I18N;
    // detect the encoding of the file name
    $detect = array('UTF-8','ISO-8859-1');
    $name = ('ISO-8859-1'==mb_detect_encoding($name,$detect))?utf8_encode($name):$name; 
    // Check file type
    if (!preg_match('/.zip$/',strtolower($name))){
      return array(false,$I18N->msg('no_zip'));
    }
    // Datei herunterladen in eine temporäre datei im Zielverzeichnis
    $input = fopen("php://input", "r");
    $temp = tmpfile();
    $realSize = stream_copy_to_stream($input, $temp);
    fclose($input);  
    // kopieren in tmp-verzeichnis
    $dir_tmp = aku_admin_getTmpDir();
    $file = $dir_tmp.$name;//tempnam($dir,'temporary');
    $target = fopen($file, "w");        
    fseek($temp, 0, SEEK_SET);
    stream_copy_to_stream($temp, $target);
    fclose($target);
    // check if is template (look for config.yml and content.php 
    $zip_rs = zip_open($file);
    $template = NULL;
    $config = NULL;
    $content = NULL;
    if(is_resource($zip_rs)){
      while ($zip_entry = zip_read($zip_rs)){
        if(zip_entry_open($zip_rs,$zip_entry)){
          // from the first entry we get the module referrer
          $name =  zip_entry_name($zip_entry);
          if(NULL === $template && ''!=$name){
            $pos = strpos($name,'/');
            if(false === $pos){
              $template = $name;
            }else{
              $template = substr($name,0,$pos); // name in front of first '/'
            }
          }
          if(preg_match('/content\.php$/',$name)){
            $content = ''; // found
            while($str = zip_entry_read($zip_entry)){
              $content.=$str;
            }
          }
        }
      }
      zip_close($zip_rs);
    }
    if(NULL === $template || NULL === $content){
      // kein korrektes format für eine template-datei
      unlink($file);
      return array(false,$I18N->msg('template_package_error'));
    }else{
      // falls Ordner im Temp-Vz. schon existiert, löschen 
      if(is_dir($dir_tmp.$template)){
        aku_admin_rmdir($dir_tmp.$template);
      }
      // zip  expandieren in tmp-verz
      if(!aku_admin_unzip($file,$dir_tmp)){
        // unzip erfolgreich, backup entfernen wenn vorhanden
        return array(false,$I18N->msg('error_unzip'));
      }
      // Verzeichnis kopieren (nicht ersetzen!)
      aku_admin_cpdir($dir_tmp.$template,aku_admin_getTemplateDir().$template);
      // zip-datei löschen
      unlink($file);
      return $this->TemplateInstall($template);
    }
  }
##############################################
# Upload Addon 
##############################################
  function UploadAddon($name){
    global $REX,$I18N;
    // detect the encoding of the file name
    $detect = array('UTF-8','ISO-8859-1');
    $name = ('ISO-8859-1'==mb_detect_encoding($name,$detect))?utf8_encode($name):$name; 
    // Check file type
    if (!preg_match('/.zip$/',strtolower($name))){
      return array(false,$I18N->msg('no_zip'));
    }
    // Datei herunterladen in eine temporäre datei im Zielverzeichnis
    $input = fopen("php://input", "r");
    $temp = tmpfile();
    $realSize = stream_copy_to_stream($input, $temp);
    fclose($input);  
    // kopieren in tmp-verzeichnis
    $dir_tmp = aku_admin_getTmpDir();
    $file = $dir_tmp.$name;//tempnam($dir,'temporary');
    $target = fopen($file, "w");        
    fseek($temp, 0, SEEK_SET);
    stream_copy_to_stream($temp, $target);
    fclose($target);
    // check if is addon (look for config.inc.php
    $zip_rs = zip_open($file);
    $addon = NULL;
    $config = NULL;
    if(is_resource($zip_rs)){
      while ($zip_entry = zip_read($zip_rs)){
        if(zip_entry_open($zip_rs,$zip_entry)){
          // from the first entry we get the module referrer
          $name =  zip_entry_name($zip_entry);
          if(NULL === $addon && ''!=$name){
            $pos = strpos($name,'/');
            if(false === $pos){
              $addon = $name;
            }else{
              $addon = substr($name,0,$pos); // name in front of first '/'
            }
          }
          if(preg_match('/config\.inc\.php$/',$name)){
            // read the zip entry to input
            $config = '';
            while($str = zip_entry_read($zip_entry)){
              $config.=$str;
            }
          }
        }
      }
      zip_close($zip_rs);
    }
    if(NULL === $addon || NULL ===$config){
      // kein korrektes format für eine addon-datei
      return array(false,$I18N->msg('addon_package_error'));
      unlink($file);
    }else{
      // falls Ordner im Temp-Vz. schon existiert, löschen 
      if(is_dir($dir_tmp.$addon)){
        aku_admin_rmdir($dir_tmp.$addon);
      }
      // zip  expandieren in tmp-verz
      if(!aku_admin_unzip($file,$dir_tmp)){
        // unzip erfolgreich, backup entfernen wenn vorhanden
        return array(false,$I18N->msg('error_unzip'));
      }
      
      // Verzeichnis kopieren (nicht ersetzen, damit plugins erhalten bleiben!)
      aku_admin_cpdir($dir_tmp.$addon,$REX['INCLUDE_PATH'].'/addons/'.$addon);

      // zip-datei löschen
      unlink($file);
      // addons-verzichnis erneuenr
      $ADDONS    = rex_read_addons_folder();
      rex_generateAddons($ADDONS);
      // this function must return the addon name as message
      // required to call install
      return array(true,$addon);// str_replace('{0}',$addon,$I18N->msg('addon_uploaded')));
    }
  }
##############################################
# Upload Plugin 
##############################################
  function UploadPlugin($name){
    global $REX,$I18N;
    // detect the encoding of the file name
    $detect = array('UTF-8','ISO-8859-1');
    $name = ('ISO-8859-1'==mb_detect_encoding($name,$detect))?utf8_encode($name):$name; 
    // Check file type
    if (!preg_match('/.zip$/',strtolower($name))){
      return array(false,$I18N->msg('no_zip'));
    }
    // Check if addon name is given and exists
    $addon = '';
    if(!isset($_GET['addon'])){
      return array(false,$I18N->msg('addon_name_undefined'));
    }else{
      // filter the addon name paremeter
      $f = array(chr(0),chr(1),chr(2),chr(3),chr(4),chr(5),chr(6),chr(7),
        chr(8),chr(11),chr(12),chr(14),chr(15),chr(16),chr(17),
        chr(18),chr(19),"\n","\r","/","\\");
      $addon = str_replace($f,' ',$_GET['addon']);
      if(!is_dir($REX['INCLUDE_PATH'].'/addons/'.$addon)){
        return array(false,$I18N->msg('addon_not_exists'));
      }
    }
    // Datei herunterladen in eine temporäre datei im Zielverzeichnis
    $input = fopen("php://input", "r");
    $temp = tmpfile();
    $realSize = stream_copy_to_stream($input, $temp);
    fclose($input);  
    // kopieren in tmp-verzeichnis
    $dir_tmp = aku_admin_getTmpDir();
    $file = $dir_tmp.$name;//tempnam($dir,'temporary');
    $target = fopen($file, "w");        
    fseek($temp, 0, SEEK_SET);
    stream_copy_to_stream($temp, $target);
    fclose($target);
    // check if is plugin (look for config.inc.php
    $zip_rs = zip_open($file);
    $plugin = NULL;
    $config = NULL;
    if(is_resource($zip_rs)){
      while ($zip_entry = zip_read($zip_rs)){
        if(zip_entry_open($zip_rs,$zip_entry)){
          // from the first entry we get the module referrer
          $name =  zip_entry_name($zip_entry);
          if(NULL === $plugin && ''!=$name){
            $pos = strpos($name,'/');
            if(false === $pos){
              $plugin = $name;
            }else{
              $plugin = substr($name,0,$pos); // name in front of first '/'
            }
          }
          if(preg_match('/config\.inc\.php$/',$name)){
            // read the zip entry to input
            $config = '';
            while($str = zip_entry_read($zip_entry)){
              $config.=$str;
            }
          }
        }
      }
      zip_close($zip_rs);
    }
    if(NULL === $plugin || NULL ===$config){
      // kein korrektes format für eine addon-datei
      return array(false,$I18N->msg('plugin_package_error'));
      unlink($file);
    }else{
      // falls Ordner im Temp-Vz. schon existiert, löschen 
      if(is_dir($dir_tmp.$addon)){
        aku_admin_rmdir($dir_tmp.$plugin);
      }
      // zip  expandieren in tmp-verz
      if(!aku_admin_unzip($file,$dir_tmp)){
        // unzip erfolgreich, backup entfernen wenn vorhanden
        return array(false,$I18N->msg('error_unzip'));
      }
      
      // Verzeichnis kopieren ins addon-vz (nicht ersetzen, damit plugins erhalten bleiben!)
      aku_admin_cpdir($dir_tmp.$plugin,$REX['INCLUDE_PATH'].'/addons/'.$addon.'/plugins/'.$plugin);

      // zip-datei löschen
      unlink($file);
      // addons-verzichnis erneuernn
      $ADDONS    = rex_read_addons_folder();
      rex_generateAddons($ADDONS);
      // this function must return the addon name as message
      // required to call install
      return array(true,str_replace('{0}',$plugin,$I18N->msg('plugin_uploaded')));
    }
  }
}
