<?php

class AKUClang {
  
  static function factory($id){
    global $REX,$I18N;
    $o = new self();
    if(-1==$id){
      $o->data = array('id'=>-1);
    }else{
      // Load Data
      $db = rex_sql::factory();
      $db->setTable($REX['TABLE_PREFIX'].'clang');
      $db->setWhere("`id`=$id LIMIT 1");
      $db->select("*");
      if(0==$db->getRows()){
        $o = NULL;
      }else{
        $o->data = $db->getRow();
        $o->data['code'] = isset($REX['CLANG_CODE'][$id])?$REX['CLANG_CODE'][$id]:'not';
        $o->data['slug'] = isset($REX['CLANG_SLUG'][$id])?$REX['CLANG_SLUG'][$id]:'def';
      }
    }
    return $o;
  }

  function setValue($name,$value){
    $this->data[$name] = $value;
  }

  function getValue($name){
    if(isset($this->data[$name])){
      return $this->data[$name];
    }else{
      return '';
    }
  }

  public function getView($name,$viewparams='') {
    global $REX;
    $params = &$viewparams; //backwards compatibility
    $view = $REX['INCLUDE_PATH'].'/addons/aku_admin/src/view.AKUClang.'.$name.'.php';
    if(file_exists($view)){
      ob_start();
      include $view;
      return ob_get_clean();
    }else{
      return '';
    }
  }
  public function save(){
    global $REX;
    if(isset($this->data['id']) && -1<$this->data['id']){
      // update
      rex_editCLang($this->getValue('id'),$this->getValue('name'));
      $db = rex_sql::factory();
      $db->setTable($REX['TABLE_PREFIX'].'clang');
      //$db->setValue('code',$db->escape($this->getValue('code')));
      //$db->setValue('slug',$db->escape($this->getValue('slug')));
      $db->setWhere("`id`=".$this->getValue('id'));
      $db->update();
    }elseif(-1==$this->data['id']){
      $db = rex_sql::factory();
      $db->setTable($REX['TABLE_PREFIX'].'clang');
      $db->setWhere("1 ORDER BY `id` DESC LIMIT 1");
      $db->select('id');
      // find new id
      if(0==$db->getRows()){
        $newid = 0;
      }else{
        $row = $db->getRow();
        $newid = $row['id'] + 1;
      }
      rex_addCLang($newid,$this->getValue('name'));
      // now add the code
      $db = rex_sql::factory();
      $db->setTable($REX['TABLE_PREFIX'].'clang');
      //$db->setValue('code',$db->escape($this->getValue('code')));
      //$db->setValue('slug',$db->escape($this->getValue('slug')));
      $db->setWhere("`id`=".$newid);
      $db->update();
      $this->data['id'] = $newid;
    }
    // slug and code are stored in aku_admin
    $REX['CLANG_CODE'][$this->getValue('id')] = $this->getValue('code');
    $REX['CLANG_SLUG'][$this->getValue('id')] = $this->getValue('slug');
    aku_admin_saveSettings();
    rex_generateAll();

  }
  
  public function ShowEdit(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    return array(true,$this->getView('edit'));
  }

  public function Delete(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
    rex_deleteCLang($this->getValue('id'));
  }
}





