<?php

class AKUModule {
  
  static function factory($id){
    global $REX,$I18N;
    $o = new self();
    if(0==$id){
      $o->data = array(
      'id'=>0,
      'revision'=>0
     );
    }else{
      // Load Data
      $db = rex_sql::factory();
      // achtung:id,name,revision,createuser etc 
      $sql = "SELECT *,".
        "t1.id AS id,".
        " t1.name as name,".
        " t1.revision as revision,".
        " t1.createdate as createdate,".
        " t1.createuser as createuser,".
        " t1.updatedate as updatedate,".
        " t1.updateuser as updateuser,".
        " t2.id AS `table_module_action_id`,".
        " t3.id AS `table_action_id`".
        "FROM `". $REX['TABLE_PREFIX'].'module` AS t1'.
        " LEFT JOIN `".$REX['TABLE_PREFIX'].'module_action` AS t2'.
        " ON t1.id = t2.module_id".
        " LEFT JOIN `".$REX['TABLE_PREFIX'].'action` AS t3'.
        " ON t2.action_id = t3.id".
        " WHERE t1.id=$id LIMIT 1";
      $db->setQuery($sql);
      if(0==$db->getRows()){
        $o = NULL;
      }else{
        $o->data = $db->getRow();
      }
    }
    return $o;
  }

  function setValue($name,$value){
    $this->data[$name] = $value;
  }

  function getValue($name){
    if(isset($this->data[$name])){
      return $this->data[$name];
    }else{
      return '';
    }
  }


  public function getView($name,$viewparams='') {
    global $REX;
    $params = &$viewparams; //backwards compatibility
    $view = $REX['INCLUDE_PATH'].'/addons/aku_admin/src/view.AKUModule.'.$name.'.php';
    if(file_exists($view)){
      ob_start();
      include $view;
      return ob_get_clean();
    }else{
      return '';
    }
  }

  public function save(){
    global $REX;
    include_once $REX['INCLUDE_PATH'].'/functions/function_rex_generate.inc.php';
    $db = rex_sql::factory();
    $db->setTable($REX['TABLE_PREFIX'].'module');
    $db->setValue('name',$db->escape($this->getValue('name')));
    $db->setValue('mod_type',$db->escape($this->getValue('mod_type')));
    $db->setValue('eingabe',$db->escape($this->getValue('eingabe')));
    $db->setValue('ausgabe',$db->escape($this->getValue('ausgabe')));
    $db->setValue('revision',intval($this->getValue('revision')));
    if(isset($this->data['id']) && 0 != $this->getValue('id')){
      // update
      $db->setValue('updatedate',time());
      $db->setValue('updateuser',aku_admin_getUserId());
      $db->setWhere("`id`=".$this->getValue('id'));
      $db->update();
      // clear cache of articles using this module
      $db->setTable($REX['TABLE_PREFIX'].'article_slice');
      $db->setWhere("`modultyp_id`=".$this->getValue('id'));
      $db->select("`article_id`,`clang`");
      $a = array();
      if(0<$db->getRows()){
        while($row=$db->getRow()){
          $a[] = $row['article_id'].'-'.$row['clang'];
        }
        $a = array_unique($a);
        foreach($a as $ic){
          list($id,$clang) = explode('-',$ic);
          rex_deleteCacheArticle($id,$clang);
        }
      }
    }else{
      // insert new
      // set updatedate also, because needed for filesystem update check
      $db->setValue('updatedate',time());
      $db->setValue('createdate',time());
      $db->setValue('updateuser',aku_admin_getUserId());
      $db->setValue('createuser',aku_admin_getUserId());
      $db->insert();
      $this->data['id'] = $db->getLastId();
    }
    // create action if required
    if(''<$this->getValue('preview') || 
      ''<$this->getValue('presave') || 
      ''<$this->getValue('postsave')){
      if(0<$this->getValue('table_action_id')){
        $this->updateAction();
      }else{
        $this->createAction();
      }
    }elseif(0<$this->getValue('table_action_id')){
      $this->deleteAction();
    }
  }

  private function createAction(){
    global $REX;
    $db = rex_sql::factory();
    // insert a row in the action_table
    $db->setTable($REX['TABLE_PREFIX'].'action');
    $db->setValue('name',$db->escape($this->getValue('name')));
    $db->setValue('revision',intval($this->getValue('revision')));
    $db->setValue('preview',$db->escape($this->getValue('preview')));
    $db->setValue('presave',$db->escape($this->getValue('presave')));
    $db->setValue('postsave',$db->escape($this->getValue('postsave')));
    $db->setValue('previewmode',intval($this->getValue('previewmode')));
    $db->setValue('presavemode',intval($this->getValue('presavemode')));
    $db->setValue('postsavemode',intval($this->getValue('postsavemode')));
    $db->setValue('createdate',time());
    $db->setValue('createuser',$REX['USER']->getValue('user_id'));
    $db->insert();
    $this->setValue('table_action_id',$db->getLastId());
    
    // insert a row in the module_action_table
    $db->setTable($REX['TABLE_PREFIX'].'module_action');
    $db->setValue('module_id',intval($this->getValue('id')));
    $db->setValue('action_id',intval($this->getValue('table_action_id')));
    $db->setValue('revision',intval($this->getValue('revision')));
    $db->insert();
    $this->setValue('table_module_action_id',$db->getLastId());
  }

  private function updateAction(){
    global $REX;
    $db = rex_sql::factory();
    $db->setTable($REX['TABLE_PREFIX'].'action');
    $db->setWhere("`id`=".$this->getValue('table_action_id'));
    $db->setValue('name',$this->getValue('name'));
    $db->setValue('revision',intval($this->getValue('revision')));
    $db->setValue('preview',$db->escape($this->getValue('preview')));
    $db->setValue('presave',$db->escape($this->getValue('presave')));
    $db->setValue('postsave',$db->escape($this->getValue('postsave')));
    $db->setValue('previewmode',intval($this->getValue('previewmode')));
    $db->setValue('presavemode',intval($this->getValue('presavemode')));
    $db->setValue('postsavemode',intval($this->getValue('postsavemode')));
    $db->setValue('updatedate',time());
    $db->setValue('updateuser',$REX['USER']->getValue('user_id'));
    $db->update();
  }

  private function deleteAction(){
    global $REX;
    $db = rex_sql::factory();
    // delete action for this module from database
    $db->setTable($REX['TABLE_PREFIX'].'module_action');
    $db->setWhere("`id`=".$this->getValue('table_module_action_id'));
    $db->delete();
    $this->setValue('table_module_action_id',0);

    $db->setTable($REX['TABLE_PREFIX'].'action');
    $db->setWhere("`id`=".$this->getValue('table_action_id'));
    $db->delete();
    $this->setValue('table_action_id',0);
  }

  public function ShowEdit(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    return array(true,$this->getView('edit'));
  }

  public function Delete(){
    // check if is in use
    global $REX,$I18N;
    $db = rex_sql::factory();
    $db->setTable($REX['TABLE_PREFIX'].'article_slice');
    $db->setWhere('`modultyp_id`='.$this->getValue('id'));
    $db->select('`article_id`');
    if(0==$db->getRows()){
      $this->deleteAction();
      $db->setTable($REX['TABLE_PREFIX'].'module');
      $db->setWhere("`id`=".$this->getValue('id'));
      $db->delete();
      // remove directory if availabel
      $dir = aku_admin_getModuleDir().$this->getValue('mod_type');
      if(is_dir($dir)){
        aku_admin_rmdir($dir);
      }
      return array(true,'');
    }else{
      $aId = array();
      while($row = $db->getRow()){
        $aId[] = $row['article_id'];
      }
      $aId = array_unique($aId);
      return array(false,
        str_replace('{0}',$this->getValue('name'),$I18N->msg('module_cannot_be_deleted')).' '.
        implode(',',$aId));
    }
  }
  

  public function Replicate(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
    // copy database content to file system
    if(''!=$this->getValue('mod_type')) return array(true,'');
    $mod_type = 'module_'.$this->getValue('id');
    $dir = aku_admin_getModuleDir().$mod_type.'/';
    if(!is_dir($dir)){
      mkdir($dir,0755,true);
    }
    file_put_contents($dir.'index.html','');
    file_put_contents($dir.'input.php',$this->getValue('eingabe'));
    file_put_contents($dir.'output.php',$this->getValue('ausgabe'));
    file_put_contents($dir.'preview.php',$this->getValue('preview'));
    file_put_contents($dir.'presave.php',$this->getValue('presave'));
    file_put_contents($dir.'postsave.php',$this->getValue('postsave'));
    $package = 'name : '.$this->getValue('name')."\n";
    $package.= 'mod_type : '.$this->getValue('mod_type')."\n";
    $package.= 'revision : '.$this->getValue('revision')."\n";
    $package.= 'previewmode : '.intval($this->getValue('previewmode'))."\n";
    $package.= 'presavemode : '.intval($this->getValue('presavemode'))."\n";
    $package.= 'postsavemode : '.intval($this->getValue('postsavemode'))."\n";
    file_put_contents($dir.'package.yml',$package);
    $this->setValue('mod_type',$mod_type);
    $this->save();
    return array(true,'');
  }
}





