<?php

class AKUPlugin {
  
  static function factory($plugin){
    global $REX;
    $o = new self();
    if(''==$plugin){
      return NULL;
    }
    $o->data= array('id'=>$plugin);
    return $o;
  }
  public function getValue($name){
    if(isset($this->data[$name])){
      return $this->data[$name];
    }else{
      return '';
    }
  }

  private function getManager(){
    $ADDONS    = rex_read_addons_folder();
    $PLUGINS = array();
    $addonname = '';
    foreach ($ADDONS as $addon){
      $PLUGINS[$addon] = rex_read_plugins_folder($addon);
      foreach($PLUGINS[$addon] as $p){
        if($p==$this->getValue('id')){
          $addonname = $addon;
          break;
        }
      }
    }
    return new rex_pluginManager($PLUGINS, $addonname);
  }
  private function getAddon(){
    $ADDONS    = rex_read_addons_folder();
    $PLUGINS = array();
    $addonname = '';
    foreach ($ADDONS as $addon){
      $PLUGINS[$addon] = rex_read_plugins_folder($addon);
      foreach($PLUGINS[$addon] as $p){
        if($p==$this->getValue('id')){
          $addonname = $addon;
          break;
        }
      }
    }
    return $addonname;
  }
  function Activate(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
     $addonManager = $this->getManager(); 
     $warning = $addonManager->activate($this->getValue('id'));
     if(true ===$warning){
       return array(true,'');
     }else{
       return array(false,$warning);
     }
 }
 function Deactivate(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
     $addonManager = $this->getManager(); 
     $warning = $addonManager->deactivate($this->getValue('id'));
     if(true ===$warning){
       return array(true,'');
     }else{
       return array(false,$warning);
     }
 }
 function Install(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
     $addonManager = $this->getManager();  
     $warning = $addonManager->install($this->getValue('id'));
     if(true ===$warning){
       return array(true,'');
     }else{
       return array(false,$warning);
     }
 }

 function Uninstall(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
     $addonManager = $this->getManager();  
     $warning = $addonManager->uninstall($this->getValue('id'));
     if(true ===$warning){
       return array(true,'');
     }else{
       return array(false,$warning);
     }
 }

  function Delete(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
    // we call neither deactivation nor uninstall, just deleted the folder
    $dir = $REX['INCLUDE_PATH'].'/addons/'.$this->getAddon().
      '/plugins/'.$this->getValue('id').'/';
    if(is_dir($dir)){
      aku_admin_rmdir($dir);
      $ADDONS    = rex_read_addons_folder();
      rex_generateAddons($ADDONS);
      return array(true,'');
    }else{
      return array(false,'plugin_delete_error_directory_not_found');
    }
  }   
}





