<?php

class AKUUser {
  
  static function factory($id){
    global $REX,$I18N;
    $o = new self();
    if(0==$id){
      $o->data = array('user_id'=>0);
    }else{
      // Load Data
      $db = rex_sql::factory();
      $db->setTable($REX['TABLE_PREFIX'].'user');
      $db->setWhere("`user_id`=$id LIMIT 1");
      $db->select("*");
      if(0==$db->getRows()){
        $o = NULL;
      }else{
        $o->data = $db->getRow();
      }
    }
    return $o;
  }

  function setValue($name,$value){
    $this->data[$name] = $value;
  }

  function getValue($name){
    if(isset($this->data[$name])){
      return $this->data[$name];
    }else{
      return '';
    }
  }

  public function getView($name,$viewparams='') {
    global $REX;
    $params = &$viewparams; //backwards compatibility
    $view = $REX['INCLUDE_PATH'].'/addons/aku_admin/src/view.AKUUser.'.$name.'.php';
    if(file_exists($view)){
      ob_start();
      include $view;
      return ob_get_clean();
    }else{
      return '';
    }
  }
  public function save(){
    global $REX;
    $db = rex_sql::factory();
    $db->setTable($REX['TABLE_PREFIX'].'user');
    $db->setValue('login',$db->escape($this->getValue('login')));
    $db->setValue('psw',$db->escape($this->getValue('psw')));
    $db->setValue('name',$db->escape($this->getValue('name')));
    $db->setValue('description',$db->escape($this->getValue('description')));
    $db->setValue('status',intval($this->getValue('status')));
    $db->setValue('rights',$db->escape($this->getValue('rights')));
    if(isset($this->data['user_id']) && 0<$this->data['user_id']){
      // update
      $db->setWhere("`user_id`=".$this->getValue('user_id'));
      $db->update();
    }else{
      $db->insert();
      $this->setValue('user_id',$db->getLastId());
    }
  }
  
  public function ShowEdit(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(true,$I18N->msg('no_access'));
    }
    return array(true,$this->getView('edit'));
  }

  public function Delete(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
    $db = rex_sql::factory();
    $db->setTable($REX['TABLE_PREFIX'].'user');
    $db->setWhere("`user_id`=".$this->getValue('user_id'));
    return $db->delete();
  }
}





