<?php
function aku_admin_load($class){
  global $REX;
  include_once $REX['INCLUDE_PATH'].'/addons/aku_admin/src/class.'.$class.'.php';
}
function AKUAdmin_load($class){
  aku_admin_load($class);
}
function aku_admin_getUserId(){
  global $REX;
  if(is_object($REX['USER'])){
    return $REX['USER']->getValue('user_id');
  }else{
    return 0;
  }
}
function aku_admin_rmdir($src) {
  $src = rtrim($src,'/');
  if(!is_dir($src)) return;
  foreach(scandir($src) as $file){
    if ('..'==$file || '.' == $file) continue;
    if (is_file($src.'/'.$file)) {
      unlink($src.'/'.$file);
    }elseif(is_dir($src.'/'.$file)){
      aku_admin_rmdir($src.'/'.$file);
    }else {
      continue;
    }
  }
  rmdir($src);
}

// $src zip file
// $dst (string) destination folder
function aku_admin_unzip($zip,$dst){
  // make sure dst ends with '/'
  $dst = rtrim($dst,'/').'/';
  $zip_rs = zip_open($zip);
  if(!is_resource($zip_rs)){
    return false;
  }
  while ($zip_entry = zip_read($zip_rs)){
    if(zip_entry_open($zip_rs,$zip_entry)){
      $name =  zip_entry_name($zip_entry);
      if(preg_match('/\/$/',$name) && !is_dir($dst.$name)){
        // ends with / is directory
        mkdir($dst.$name,0755,true);
      }else{
        $fh = fopen($dst.$name,'w');
        // read the zip entry to input
        while($str = zip_entry_read($zip_entry)){
          fwrite($fh,$str);
        }
        fclose($fh);
      }
    }
  }
  zip_close($zip_rs);
  return true;
}


function aku_admin_cpdir($src,$dst){
  if(!is_dir($src)) return;
  $dst = rtrim($dst,'/').'/';
  $src = rtrim($src,'/').'/';
  if(!is_dir($dst)){
    mkdir($dst,0755,true);
  }
  foreach(scandir($src) as $file){
    if('.'==$file || '..'==$file) continue;
    if(is_dir($src.$file)){
      aku_admin_cpdir($src.$file.'/',$dst.$file.'/');
    }else{
      copy($src.$file,$dst.$file);
    }
  }
}

function aku_admin_getSystemApps(){
  // used for internal subnav and clientius main nav
  global $REX,$I18N;
  $a = array();
  $i=0;
  $a[$i]['name'] = $I18N->msg('system_info');
  $a[$i]['href'] = 'index.php?page=aku_admin#AKUAdmin-0-info';
  $a[$i]['children'] = array();
  $i++;

  if($REX['USER']->isAdmin()){
    $a[$i]['name'] = $I18N->msg('modules');
    $a[$i]['href'] = 'index.php?page=aku_admin#AKUAdmin-0-modules';
    $a[$i]['children'] = array();
    $i++;
  }
  
  if($REX['USER']->isAdmin()){
    $a[$i]['name'] = $I18N->msg('addons');
    $a[$i]['href'] = 'index.php?page=aku_admin#AKUAdmin-0-addons';
    $a[$i]['children'] = array();
    $i++;
  }

  if($REX['USER']->isAdmin() ){
    $a[$i]['name'] = $I18N->msg('templates');
    $a[$i]['href'] = 'index.php?page=aku_admin#AKUAdmin-0-templates';
    $a[$i]['children'] = array();
    $i++;
  }

  if($REX['USER']->isAdmin()){
    $a[$i]['name'] = $I18N->msg('languages');
    $a[$i]['href'] = 'index.php?page=aku_admin#AKUAdmin-0-languages';
    $a[$i]['children'] = array();
    $i++;
  }
  if($REX['USER']->isAdmin() ){
    $a[$i]['name'] = $I18N->msg('backup_export');
    $a[$i]['href'] = 'index.php?page=aku_admin#AKUAdmin-0-backupexport';
    $a[$i]['children'] = array();
    $i++;
  }
  if($REX['USER']->isAdmin()){ 
    $a[$i]['name'] = $I18N->msg('user');
    $a[$i]['href'] = 'index.php?page=aku_admin#AKUAdmin-0-users';
    $a[$i]['children'] = array();
    $i++;
  }
  // Main applications
  if(!isset($REX['AKU_ADMIN_NAV'])){
    $topnav = '';
  }else{
    $topnav = ','.$REX['AKU_ADMIN_NAV'].',';
  }
  foreach(OOAddon::getAvailableAddons() as $addon){
    // addon has no backend
    if(!isset($REX['ADDON']['name'][$addon])) continue;
    // aku_admin must not be registered
    if('aku_admin'==$addon) continue;
    // not a system app
    if(!isset($REX['ADDON']['navigation'][$addon]['block'])) continue;
    if('system'!=$REX['ADDON']['navigation'][$addon]['block']) continue; 
    // top-apps must not be listed here
    if(false !== strpos($topnav,$addon)) continue;

    if($REX['USER']->isAdmin() || $REX['USER']->hasPerm($addon.'[]')){
      $a[$i]['name'] = $REX['ADDON']['name'][$addon];
      $a[$i]['href'] = 'index.php?page='.$addon;
      $a[$i]['children'] = array();
      $i++;
    }
  }
  return $a;
}

// function to create the settings file
// clang code + slug
// aku_admin_rewrite are being saved
function aku_admin_saveSettings(){
  global $REX;
  $s = '<'.'?'.'php'."\n";
  $s.= 'isset($REX) or die();'."\n";
  // Read clang slug and code from db
  $db = rex_sql::factory();
  $db->setTable($REX['TABLE_PREFIX'].'clang');
  $db->setWhere('1');
  $db->select('id');
  if(0==$db->getRows()) return;
  while ($row = $db->getRow()){
    // first load (e.g. setup) code and slug are not known
    if(!isset($REX['CLANG_CODE'][$row['id']])){
      $REX['CLANG_CODE'][$row['id']] = 'de-DE';
    }
    if(!isset($REX['CLANG_SLUG'][$row['id']])){
      $REX['CLANG_SLUG'][$row['id']] = 'de';
    }
    $s.= '$REX[\'CLANG_CODE\']['.$row['id'].'] = \''.$REX['CLANG_CODE'][$row['id']].'\';'."\n";
    $s.= '$REX[\'CLANG_SLUG\']['.$row['id'].'] = \''.$REX['CLANG_SLUG'][$row['id']].'\';'."\n";
  }
  if(!isset($REX['AKU_ADMIN_REWRITE'])){
    $s.= '$REX[\'AKU_ADMIN_REWRITE\'] = \'default\';'."\n";
  }else{
    $s.= '$REX[\'AKU_ADMIN_REWRITE\'] = \''.$REX['AKU_ADMIN_REWRITE'].'\';'."\n";
  }
  if(!isset($REX['AKU_ADMIN_REWRITE_MULTILANG'])){
    $s.= '$REX[\'AKU_ADMIN_REWRITE_MULTILANG\'] = \'1\';'."\n";
  }else{
    $s.= '$REX[\'AKU_ADMIN_REWRITE_MULTILANG\'] = \''.$REX['AKU_ADMIN_REWRITE_MULTILANG'].'\';'."\n";
  }
  if(!isset($REX['AKU_ADMIN_NAV'])){
    $s.= '$REX[\'AKU_ADMIN_NAV\'] = \'brm_order,brm_product,brm_event,brm_gallery,brm_contact\';'."\n";
  }else{
    $s.= '$REX[\'AKU_ADMIN_NAV\'] = \''.$REX['AKU_ADMIN_NAV'].'\';'."\n";
  }
  if(!isset($REX['AKU_ADMIN_RUNMODE'])){
    $s.= '$REX[\'AKU_ADMIN_RUNMODE\'] = \'prod\';'."\n";
  }else{
    $s.= '$REX[\'AKU_ADMIN_RUNMODE\'] = \''.$REX['AKU_ADMIN_RUNMODE'].'\';'."\n";
  }
  file_put_contents($REX['HTDOCS_PATH'].'files/addons/aku_admin/aku_admin_settings.php',$s);
}

function aku_admin_getHeader(){
  global $REX,$I18N;
  ob_start();
  if ($REX['USER']) {
    $aNav = array();
    $i=0;
    if(OOAddon::isAvailable('aku_structure')){
      $aNav[$i]['name'] = $I18N->msg("page_structure");
      $aNav[$i]['href'] = 'index.php?page=aku_structure';
      $aNav[$i]['children'] = array();
      $i++;
    }else{
      $aNav[$i]['name'] = $I18N->msg("page_structure");
      $aNav[$i]['href'] = '';
      $aNav[$i]['children'] = array(
        array(
          'name' => $I18N->msg("structure"),
          'href' => 'index.php?page=structure',
          'children' => array()
        ),
        array(
          'name' => $I18N->msg("mediapool"),
          'href' => 'index.php?page=mediapool',
          'children' => array()
        )
      );
      $i++;
    }
    // Main applications
    if(!isset($REX['AKU_ADMIN_NAV'])){
      $p = array();
    }else{
      $p = explode(',',$REX['AKU_ADMIN_NAV']);
    }
    foreach($p as $addon){
      if(''==trim($addon)) continue;
      if(OOAddon::isAvailable($addon) &&
      ($REX['USER']->isAdmin() || $REX['USER']->hasPerm($addon.'[]'))){
        $aNav[$i]['name'] = $REX['ADDON']['name'][$addon];
        $aNav[$i]['href'] = 'index.php?page='.$addon;
        $aNav[$i]['children'] = array();
        $i++;
      }
    }
    
    $aNav[$i]['name'] = $I18N->msg("header_applications");
    $aNav[$i]['href'] = '';
    $aNav[$i]['children'] = aku_admin_getApps();
    $i++;

    if(OOAddon::isAvailable('aku_admin')){
      $aNav[$i]['name'] = $I18N->msg("header_system");
      $aNav[$i]['href'] = '';
      $aNav[$i]['children'] = aku_admin_getSystemApps();
      $i++;
    }else{
      $aNav[$i]['name'] = $I18N->msg("header_system");
      $aNav[$i]['href'] = '';
      $aNav[$i]['children'] = aku_admin_getSystemApps();
      $i++;
    }
    
    echo '<div id="aku_admin_header"><div id="aku_admin_header_i">';
    echo '<div id="aku_admin_navi_main"><div id="aku_admin_navi_main_i">';
    echo '<ul class="level0">';
    foreach($aNav as $n0){
      echo '<li class="level0">';
      if (0<count($n0['children'])){
        echo '<a onclick="aku_admin_toggleSubNav(this);return false;"';
        echo ' style="cursor:pointer;" >';
      }else{
        echo '<a href="'.$n0['href'].'">';
      }
      echo '<span>'.htmlspecialchars($n0['name']).'</span></a>';
      if(0<count($n0['children'])){
        echo '<ul class="level1">';
        foreach($n0['children'] as $n1){
          echo '<li class="level1"><a';
          echo ' onclick="aku_admin_closeNav(this);return true;"';
          echo ' href="'.$n1['href'].'">';
          echo '<span>'.htmlspecialchars($n1['name']).'</span></a></li>';
        }
        echo '</ul>';
      }
      echo '</li>';
    }
    echo '<a target="_blank" href="../index.php"">'.
    '<img id="aku_admin_main_icon" src="'.
    './media/addons/aku_admin/site.png"></a>';
    echo '</div></div>';
    echo '<div id="aku_admin_user_navi"><div id="aku_admin_user_navi_i">';
    $user_name = $REX['USER']->getValue('name') != '' ? $REX['USER']->getValue('name') : $REX['USER']->getValue('login');
    echo '<a href="index.php?page=profile">'.$I18N->msg('profile_title').'</a>';
    echo '&nbsp;<a href="index.php?rex_logout=1">'.$I18N->msg('logout').'</a>';
    echo '&nbsp;'.$I18N->msg('logged_in_as').' '.htmlspecialchars($user_name);
    echo '</div></div>';
    echo '</div></div>';
  }else{
    echo '<div id="aku_admin_header"><div id="aku_admin_header_i">';
    echo '<div id="aku_admin_user_navi"><div id="aku_admin_user_navi_i">';
    echo '&nbsp;<a href="index.php">'.$I18N->msg('logged_out').'</a>';
    echo '</div>';
    echo '</div>';
  }
  return ob_get_clean();
}

function aku_admin_getApps(){
  global $REX,$I18N;
  $a = array();
  $i=0;
  if(!isset($REX['AKU_ADMIN_NAV'])){
    $topnavs = '';
  }else{
    $topnavs = ','.$REX['AKU_ADMIN_NAV'].',';
  }
  foreach(OOAddon::getAvailableAddons() as $addon){
    // addon has no backend
    if(!isset($REX['ADDON']['name'][$addon])) continue;
    // aku_structure is always on the left
    if('aku_structure'==$addon) continue;
    // addon is in top navs
    if(false!==strpos($topnavs,','.$addon.',')) continue;
    // don't list system addons
    if(isset($REX['ADDON']['navigation'][$addon]['block']) &&
    'system'==$REX['ADDON']['navigation'][$addon]['block']){
      // aku_admin lists these under "system" 
      continue;
    }
    
    if($REX['USER']->isAdmin() || 
    $REX['USER']->hasPerm($addon.'[]')){ 
      $a[$i]['name'] = $REX['ADDON']['name'][$addon];
      $a[$i]['href'] = 'index.php?page='.$addon;
      $a[$i]['children'] = array();
      $i++;
    }
  }
  return $a;
}

function aku_admin_getFooter(){
  global $REX,$I18N;
  ob_start();
  echo '<div id="aku_admin_footer"><div id="aku_admin_footer_i">';
  echo '&copy;'.date("Y",time()).' <a href="http://azular.com" target="_blank">Azular GmbH</a>'.
  ' - <a href="http://redaxo.org" target="_blank">Redaxo CMS</a>';
  echo '</div></div>';
  return ob_get_clean();
}
function aku_admin_getTmpDir(){
  global $REX;
  return $REX['HTDOCS_PATH'].'tmp/';
}

function aku_admin_getModuleDir(){
  global $REX;
  return $REX['HTDOCS_PATH'].'modules/';
}
function aku_admin_getTemplateDir(){
  global $REX;
  return $REX['HTDOCS_PATH'].'templates/';
}
function aku_admin_getBackupDir(){
  global $REX;
  return $REX['INCLUDE_PATH'].'/data/addons/aku_admin/';
}

function aku_admin_getPathesFile(){
  global $REX;
  return  $REX['INCLUDE_PATH'].'/generated/aku_admin_pathes.ini';
}


function aku_admin_getCategoryOptions($oocat=NULL,$level = 0){
   $a = array();
  if(NULL === $oocat){
    $aCats = OOCategory::getRootCategories();
    foreach($aCats as $cat){
      $a['csw['.$cat->getId().']'] = $cat->getName().' (#'.$cat->getId().')';
      foreach(aku_admin_getCategoryOptions($cat,$level+1) as  $key=>$val){
        $a[$key] = $val;
      }
    }
  }else{
    foreach($oocat->getChildren() as $cat){
      $a['csw['.$cat->getId().']'] = str_repeat(' ',$level).' '.$cat->getName().
        ' (#'.$cat->getId().')';
      foreach(aku_admin_getCategoryOptions($cat,$level+1) as $key=>$val){
        $a[$key] = $val;
      }
    } 
  }
  return $a;
}
function aku_admin_getMediaCategoryOptions($oocat=NULL,$level = 0){
  $a = array();
  if(NULL === $oocat){
    $aCats = OOMediaCategory::getRootCategories();
    foreach($aCats as $cat){
      $a['media['.$cat->getId().']'] = $cat->getName().' (#'.$cat->getId().')';
      foreach(aku_admin_getMediaCategoryOptions($cat,$level+1) as  $key=>$val){
        $a[$key] = $val;
      }
    }
  }else{
    foreach($oocat->getChildren() as $cat){
      $a['media['.$cat->getId().']'] = str_repeat(' ',$level).' '.$cat->getName().
        ' (#'.$cat->getId().')';
      foreach(aku_admin_getMediaCategoryOptions($cat,$level+1) as $key=>$val){
        $a[$key] = $val;
      }
    }

  }
  return $a;
}
function aku_admin_loadPathes(){
  global $REX;
  if(!isset($REX['AKU_ADMIN']['PATHES'])){
    if(!file_exists(aku_admin_getPathesFile())){
      aku_admin_buildPathesFile();
    }
    $REX['AKU_ADMIN']['PATHES'] = parse_ini_file(aku_admin_getPathesFile(),false);
  }
}

function aku_admin_buildPathesFile(){
  global $REX;
  $db = rex_sql::factory();
  $db->setTable($REX['TABLE_PREFIX'].'article');
  $db->setWhere(" true ");
  $db->select('id,clang,name,catname,path,startpage,re_id');
  // Bilde Daten-Array. Required to find all catnames of path
  $a = array();
  if(0<$db->getRows()){
    while($row = $db->getRow()){
      $a['&article_id='.$row['id'].'&clang='.$row['clang']] = $row;
    }
  }
  $pathes = '';
  $pathes = array(); 
  foreach($a as $url=>$row){
    $path_key = '/';
    if(1<count($REX['CLANG']) || 
    (isset($REX['AKU_ADMIN_REWRITE_MULTILANG']) && 1 == $REX['AKU_ADMIN_REWRITE_MULTILANG'])
    ){
      // wenn mehr als eine Sprache oder mehrsprachig gewünscht, language slug voran setzen
      $path_key.= $REX['CLANG_SLUG'][$row['clang']].'/';
    }
    // root-categories: add catname
    if('|'==$row['path'] && 1==$row['startpage']){
      $path_key.= strtolower(rex_parse_article_name($row['catname'])).'/';
    }
    // path durchlaufen und catnames aufreihen
    foreach(explode('|',$row['path']) as $catid){
      if(''==trim($catid)) continue;
      $path_key.= strtolower(rex_parse_article_name($row['catname'])).'/';
    }
    // artieklname anhängen
    if(0==$row['startpage']){
      $path_key.= strtolower(rex_parse_article_name($row['name']));//'/';
    }
    $pathes[$path_key] = $url;
    //$pathes.= $path_key.' = "&article_id='.$article_id.'&clang='.$clang.'"'."\n";
  }
  // root and language pathes must be appended, so that array_search finds article url first
  $pathes['/'] = '&article_id='.$REX['START_ARTICLE_ID'].'&clang=0';
  foreach($REX['CLANG'] as $key=>$val){
    $pathes['/'.$REX['CLANG_SLUG'][$key].'/'] = '&article_id='.$REX['START_ARTICLE_ID'].'&clang='.$key;
  }
  // ----- EXTENSION POINT
  // page variable validated
  //$pathes = rex_register_extension_point('AKU_ADMIN_PATHES', $pathes, array(),false);

  $pathes_file = aku_admin_getPathesFile(); 
  $fh = fopen($pathes_file,'w');
  foreach($pathes as $key=>$url){
    fputs($fh,$key.' = "'.$url.'"'."\n");
  }
  fclose($fh);
  //file_put_contents($pathes_file, $pathes);
}



