<?php
AKUAdmin_load('AKUAdminForm');
global $REX,$I18N;

$errMsg = '';
$okMsg = '';

$form = AKUAdminForm::factory("userform1");
$form->useAjax = true;
$form->setUrl('local_sendForm(this);return false;');
$isNew = false;
if(0==$this->getValue('user_id')){
  $isNew = true;
}
if($isNew){
  $form->addField('login','text',1,$this->getValue('login'),'','/^[0-9a-z_]+$/', 'size=50','');
}
$form->addField('name','text',1,$this->getValue('name'),'','text', 'size="50"','');
$form->addField('description','text',0,$this->getValue('description'),'','text', 'size="50"','');
$form->addField('psw','text',0,'','','text', 'size="50"','');
$form->addField('status','checkbox',0,$this->getValue('status'),'','text', 'size="50"','');
$form->addField('admin','checkbox',0,false===strpos($this->getValue('rights'),'#admin[]#')?0:1, '','', '','');
// Language access
$aLang = array();
$aOptions = array();
foreach($REX['CLANG'] as $key=>$lang){
  $aOptions['clang['.$key.']'] = $lang;
  if(false !== strpos($this->getValue('rights'),'#clang['.$key.']#')){
    $aLang[] = 'clang['.$key.']';
  }
}
$form->addField('clang','multicheckbox',0,$aLang, $aOptions,'keys', '','');

// Backend-Sprache
$aOptions = array(''=>'default');
$be_lang = '';
foreach(scandir($REX['INCLUDE_PATH'] . '/lang/') as $file){
  if (substr($file, -5) != '.lang') continue;
  $lang = str_replace('.lang','',$file);
  $aOptions['be_lang['.$lang.']'] = $I18N->msg($lang);
  if(false!==strpos($this->getValue('rights'),'#be_lang['.$lang.']#')){
    $be_lang = 'be_lang['.$lang.']';
  }
}
$form->addField('be_lang','select',0,$be_lang,$aOptions,'keys', '','');


// Standardseite
$aOptions = array(''=>'default');
$startpage = '';
foreach(OOAddon::getAvailableAddons() as $addon){
  $tag = 'startpage['.$addon.']';
  if(isset($REX['ADDON']['name'][$addon])){
    $aOptions[$tag] = $REX['ADDON']['name'][$addon];
  }
  if(false!==strpos($this->getValue('rights'),'#'.$tag.'#')){
    $startpage = $tag;
  }
}
$form->addField('startpage','select',0,$startpage,$aOptions,'keys', '','');

// general access
$aOptions = $REX['PERM'];
sort($aOptions);
$aSelection = array();
foreach($aOptions as $opt){
  $tag = $opt;
  if(false !== strpos($this->getValue('rights'),'#'.$tag.'#')){
    $aSelection[] = $opt;
  }
}
$form->addField('access','multicheckbox',0,$aSelection,$aOptions,'values', '','');

// module
$aOptions = array();
$aSelection = array();
$db = rex_sql::factory();
$db->setQuery('select * from ' . $REX['TABLE_PREFIX'] . 'module order by name');
if(0<$db->getRows()){
  while ($row=$db->getRow()){
    $tag = 'module['.$row['id'].']';
    $aOptions[$tag] = $row['name'];
    if(false !== strpos($this->getValue('rights'),'#'.$tag.'#')){
      $aSelection[] = $tag;
    }
  }
}
$form->addField('module','multicheckbox',0,$aSelection,$aOptions,'keys', '','');

// categories
$aOptions = aku_admin_getCategoryOptions();
$aSelection = array();
foreach($aOptions as $tag=>$val){
  if(false!==strpos($this->getValue('rights'),'#'.$tag.'#')){
    $aSelection[] = $tag;
  }
}
$form->addField('categories','multicheckbox',0,$aSelection,$aOptions,'keys', '','');
$form->addField('allcategories','checkbox',0,
  false!==strpos($this->getValue('rights'),'#csw[0]#')?1:0,
  '','',
  'onclick="var e=document.getElementById(\'catsel\');'.
  'if(this.checked){e.style.display=\'none\';'.
  '}else{'.
  'e.style.display=\'block\';};"','');
// media categories
$aOptions = aku_admin_getMediaCategoryOptions();
$aSelection = array();
foreach($aOptions as $tag=>$val){
  if(false!==strpos($this->getValue('rights'),'#'.$tag.'#')){
    $aSelection[] = $tag;
  }
}
$form->addField('media','multicheckbox',0,$aSelection,$aOptions,'keys', '','');
$form->addField('allmedia','checkbox',0,
  false!==strpos($this->getValue('rights'),'#media[0]#')?1:0,
  '','',
  'onclick="var e=document.getElementById(\'mediasel\');'.
  'if(this.checked){e.style.display=\'none\';'.
  '}else{'.
  'e.style.display=\'block\';};"','');

// extra (hidden field)
$aOptions = $REX['EXTRAPERM'];
$aSelection = array();
foreach($aOptions as $opt){
  $tag = $opt;
  if(false !== strpos($this->getValue('rights'),'#'.$tag.'#')){
    $aSelection[] = $tag;
  }
}
$form->addField('extraperm','multicheckbox',0,$aSelection,$aOptions,'','', '','');


// extended (hidden field)
$aOptions = $REX['EXTPERM'];
$aSelection = array();
foreach($aOptions as $opt){
  $tag = $opt;
  if(false !== strpos($this->getValue('rights'),'#'.$tag.'#')){
    $aSelection[] = $tag;
  }
}
$form->addField('extperm','multicheckbox',0,$aSelection,$aOptions,'','', '','');


if(true === $form->isValid()){
  if($isNew){
    $this->setValue('login',$form->getValue('login'));
  }
  if(''<$form->getValue('psw')){
    if ($REX['PSWFUNC'] != '' ){
      $this->setValue('psw', call_user_func($REX['PSWFUNC'], $form->getValue('psw')));
    }else{
      $this->setValue('psw',$form->getValue('psw'));
    }
  }
  $this->setValue('description',$form->getValue('description'));
  $this->setValue('name',$form->getValue('name'));
  if($this->getValue('user_id') == $REX['USER']->getValue('user_id') ||
  1 == $form->getValue('status')){
    // aktueller user kann sich selbst nicht ausschalten
    $this->setValue('status',1);
  }else{
    $this->setValue('status',0);
  }
  // Rights setzen
  $r = '#';
  if(''!= $form->getValue('startpage')){
    $r.= $form->getValue('startpage').'#';
  }

  if(''!= $form->getValue('be_lang')){
    $r.= $form->getValue('be_lang').'#';
  }

  if($this->getValue('user_id')== $REX['USER']->getValue('user_id') ||
  1==$form->getValue('admin')){
    // if the actual user is editing, it must be admin
    $r.='admin[]#';
  }
  if(0<count($form->getValue('clang'))){
    $r.=implode('#',$form->getValue('clang')).'#';
  }
  if(0<count($form->getValue('extperm'))){
    $r.=implode('#',$form->getValue('extperm')).'#';
  }
  if(0<count($form->getValue('extraperm'))){
    $r.=implode('#',$form->getValue('extraperm')).'#';
  }
  if(1==$form->getValue('allmedia')){
    $r.='media[0]#';
  }elseif(0<count($form->getValue('media'))){
    $r.=implode('#',$form->getValue('media')).'#';
  }
  if(1==$form->getValue('allcategories')){
    $r.='csw[0]#';
  }elseif(0<count($form->getValue('categories'))){
    $r.=implode('#',$form->getValue('categories')).'#';
  }
  if(0<count($form->getValue('module'))){
    $r.=implode('#',$form->getValue('module')).'#';
  }
  if(0<count($form->getValue('access'))){
    $r.=implode('#',$form->getValue('access')).'#';
  }
  $this->setValue('rights',$r);
  $this->save();
  $return = '{"success":true,"returnto":"AKUAdmin-0-users"}';
  while (ob_get_level()) { ob_end_clean(); }
  die($return);
}elseif(true===$form->isSent()){
  $errMsg = $form->getError();
}

##########################################################################
# Ausgabe 
##########################################################################
echo '<div id="ClientClangEdit">';
if($isNew){
  echo '<h1>'.$I18N->msg('add_user').'</h1>';
}else{
  echo '<h1>'.$I18N->msg('edit_user').'</h1>';
}
echo $form->getFormHeader();
echo '<div class="structure_block">';
echo '<p><input type="submit" value="'.$I18N->msg('form_save').'" />&nbsp;'.
  '<a href="" onclick="location.hash=\'AKUAdmin-0-users\';return false;">'.
  $I18N->msg('form_abort').'</a></p>';

if(''<$errMsg){
  echo '<p class="error">'.$errMsg.'</p>';
}
echo '<table class="rex-table">';
if($isNew){
  echo '<tr><td>'. $I18N->msg('login').
    '<br/>'.$form->getField('login').
    '<div><i>'.$form->getError('login').'</i></div>';
}else{
  echo '<tr><td>ID: '.$this->getValue('user_id');
  echo '<tr><td>'.$I18N->msg('login_name').': '.$this->getValue('login');
}
echo '<tr><td>'. $form->getField('status').' '.$I18N->msg('user_status');
echo '<tr><td>'. $form->getField('admin').' '.$I18N->msg('user_admin');
echo '<tr><td><strong>'. $I18N->msg('password').'</strong>'.
  '<br/>'.$form->getField('psw').
  '<div><i>'.$I18N->msg('psw_encrypted').'</i></div>';

echo '<tr><td><strong>'. $I18N->msg('name').'</strong>'.
  '<br/>'.$form->getField('name').
  '<div><i>'.$form->getError('name').'</i></div>';

echo '<tr><td><strong>'. $I18N->msg('description').'</strong>'.
  '<br/>'.$form->getField('description').
  '<div><i>'.$form->getError('description').'</i></div>';
echo '<tr><td><strong>'. $I18N->msg('user_lang_xs').'</strong>'.
  '<br/>'.$form->getField('clang');
echo '<tr><td><strong>'. $I18N->msg('backend_language').'</strong>'.
  '<br/>'.$form->getField('be_lang');
echo '<tr><td><strong>'. $I18N->msg('startpage').'</strong>'.
  '<br/>'.$form->getField('startpage');
echo '<tr><td><strong>'. $I18N->msg('user_all').'</strong>'.
  '<br/>'.$form->getField('access');
echo '<tr><td><strong>'. $I18N->msg('modules').'</strong>'.
  '<br/>'.$form->getField('module');

$style = '';
if(1==$form->getValue('allcategories')){
  $style = ' style="display:none;"';
}
echo '<tr><td>'.$form->getField('allcategories').' <strong>'.$I18N->msg('all_categories').
  '</strong><br/><br/><div id="catsel"'.$style.'>'.$form->getField('categories').'</div>';
$style = '';
if(1==$form->getValue('allmedia')){
  $style = ' style="display:none;"';
}
echo '<tr><td>'.$form->getField('allmedia').' <strong>'.$I18N->msg('all_mediafolder').
  '</strong><br/><br/><div id="mediasel"'.$style.'>'.$form->getField('media').'</div>';

echo '<tr><td><strong>'. $I18N->msg('extras').'</strong>'.
  '<br/><br/>'.$form->getField('extraperm');
echo '<tr><td><strong>'. $I18N->msg('user_options').'</strong>'.
  '<br/><br/>'.$form->getField('extperm');
echo '</table>';
echo $form->getFormFooter();

echo '</div>';
echo '</div>';

